# coding: utf-8

"""
Binance Pay REST API

OpenAPI Specification for the Binance Pay REST API
The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from binance_sdk_pay.rest_api.models.get_pay_trade_history_response_data_inner_funds_detail_inner_wallet_asset_cost_inner import (
    GetPayTradeHistoryResponseDataInnerFundsDetailInnerWalletAssetCostInner,
)
from typing import Set
from typing_extensions import Self


class GetPayTradeHistoryResponseDataInnerFundsDetailInner(BaseModel):
    """
    GetPayTradeHistoryResponseDataInnerFundsDetailInner
    """  # noqa: E501

    currency: Optional[StrictStr] = None
    amount: Optional[StrictStr] = None
    wallet_asset_cost: Optional[
        List[GetPayTradeHistoryResponseDataInnerFundsDetailInnerWalletAssetCostInner]
    ] = Field(default=None, alias="walletAssetCost")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["currency", "amount", "walletAssetCost"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def is_array(cls) -> bool:
        return False

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetPayTradeHistoryResponseDataInnerFundsDetailInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set(
            [
                "additional_properties",
            ]
        )

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in wallet_asset_cost (list)
        _items = []
        if self.wallet_asset_cost:
            for _item_wallet_asset_cost in self.wallet_asset_cost:
                if _item_wallet_asset_cost:
                    _items.append(_item_wallet_asset_cost.to_dict())
            _dict["walletAssetCost"] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetPayTradeHistoryResponseDataInnerFundsDetailInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "currency": obj.get("currency"),
                "amount": obj.get("amount"),
                "walletAssetCost": (
                    [
                        GetPayTradeHistoryResponseDataInnerFundsDetailInnerWalletAssetCostInner.from_dict(
                            _item
                        )
                        for _item in obj["walletAssetCost"]
                    ]
                    if obj.get("walletAssetCost") is not None
                    else None
                ),
            }
        )
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj
